SystemOrganization addCategory: #'Xpf-Multipoint-Plugin'!

SmartSyntaxInterpreterPlugin subclass: #MultiPointerPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'mig 6/10/2009 13:48'!
hasHeaderFile

	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^ true! !

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'mig 6/10/2009 13:48'!
requiresPlatformFiles

	"this plugin requires platform specific files in order to work"
	^ true! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'mig 6/10/2009 13:47'!
initialiseModule

	self export: true.
	^ self cCode: 'multiPointerInit()' inSmalltalk: [true]! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'mig 6/10/2009 13:47'!
moduleUnloaded: aModuleName 

	self export: true.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 8/13/2009 15:13'!
primitiveMultiPointerBufferSemaphoreHandle: aSemaIndex

	self primitive: 'multiPointerSetBufferSemaphoreHandle' parameters: #(SmallInteger).
	self multiPointerSetBufferSemaphore: aSemaIndex.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 8/13/2009 14:22'!
primitiveMultiPointerDeviceCount

	self primitive: 'primitiveMultiPointerDeviceCount'.
	^ self multiPointerDeviceCount asSmallIntegerObj! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 8/13/2009 15:13'!
primitiveMultiPointerDeviceLively: aPointerID

	self primitive: 'primitiveMultiPointerDeviceLively' parameters: #(SmallInteger).
	^ (self multiPointerDeviceLively: (aPointerID asCUnsigned)) asSmallIntegerObj! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 8/19/2009 13:51'!
primitiveMultiPointerEventAvailable

	self primitive: 'primitiveMultiPointerEventAvailable'.
	^ self multiPointerEventAvailable asSmallIntegerObj! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 8/13/2009 15:30'!
primitiveMultiPointerGetNextEvent: anArray
	"Primitive. Return the next input event from the VM event queue."
	| evtBuf value |
	self primitive: 'primitiveMultiPointerGetNextEvent' parameters: #(Array).
	
	self var: #evtBuf declareC:'int evtBuf[8] = { 0, 0, 0, 0, 0, 0, 0, 0 }'.
	
	self multiPointerGetNextEvent: evtBuf.

	"Event arguments"
	0 to: 7 do:[:i|
		value := evtBuf at: i.
		(self isIntegerValue: value)
			ifTrue:[self storeInteger: i-1 ofObject: anArray withValue: value]
			"ifFalse:[self fail]"].! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 8/27/2009 14:58'!
primitiveMultiPointerReset

	self primitive: 'primitiveMultiPointerReset'.
	self multiPointerReset.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 8/13/2009 14:24'!
primitiveMultiPointerSetBufferSemaphore: aSemaIndex

	self primitive: 'primitiveMultiPointerSetBufferSemaphore' parameters: #(SmallInteger).
	self multiPointerSetBufferSemaphore: aSemaIndex.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 8/13/2009 14:24'!
primitiveMultiPointerUseMultiInput

	self primitive: 'primitiveMultiPointerUseMultiInput'.
	self multiPointerUseMultiInput.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 8/13/2009 14:24'!
primitiveMultiPointerUseOSInput

	self primitive: 'primitiveMultiPointerUseOSInput'.
	self multiPointerUseOSInput.! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'mig 6/10/2009 13:47'!
shutdownModule

	self export: true.
	^ self cCode: 'multiPointerShutdown()' inSmalltalk: [true]! !
